/*
 * Javascript HTML welcome screen config control
 *
 * Licensed Materials - Property of IBM - some unique copyrights (i.e., the ability 
 * to copy, modify, distribute) may be licensed in certain circumstances 
 * (e.g., sample/template code intended to be used by customers to build upon and 
 * distribute as their own products).

 * DOORS - %full_filespec: config.js~9:javascript:ERS#1 %  %date_created: Tue Mar 31 15:39:03 2009 %

 * (c) Copyright IBM Corporation 1993, 2008. All Rights Reserved.

 * U.S. Government Users Restricted Rights: Use, duplication or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp.

 */

function getSection(ctrl) // IN: control to find parent section DIV for
//
// DESCRIPTION: Returns the parent section element if found 
//
{
    if (ctrl.id 
        && 0 == ctrl.id.indexOf("section_"))
    {
        return ctrl;
    }
  
    var parent = ctrl.parentElement;
    while (parent
        && "div" != parent.tagName.toLowerCase()
        && (!parent.id || 0 != parent.id.indexOf("section_")))
    {
        parent = parent.parentElement;
    }
 
    return parent;
}

function onLinkDblClick()
//
// DESCRIPTION: Cancels any double click event
//
{
    event.cancelBubble = true;
    event.returnValue = false;
}

function onLinkClick()
//
// DESCRIPTION: Cancels any click event
//
{
    event.cancelBubble = true;
    event.returnValue = false;
}

function onResize()
//
// DESCRIPTION: Moves the edit buttons whenever a section is changed in size
//
{
    // Move edit link button for each section
    for (var i = 1; i <= 6; i++)
    {
        // Find section
        var section_id = "section_" + i;
        var section = document.getElementById(section_id);

        // Find editLink
        var editLink_id = "section_edit_" + i;
        var editLink = document.getElementById(editLink_id);

        if (null != editLink)
        {
            // Position button/link above link text
            editLink.style.left = getCtrlRight(section) - editLink.offsetWidth - 5;
            editLink.style.top = getCtrlTop(section) + 5;
        }
    }
}

function onLoad()
//
// DESCRIPTION: Returns the parent section element if found 
//
{
    // Remove the links from TAB order and hide focus
    link_1.tabIndex = -1;
    link_2.tabIndex = -1;
    link_3.tabIndex = -1;
    link_4.tabIndex = -1;
    link_5.tabIndex = -1;
    link_6.tabIndex = -1;
    link_1.hideFocus = true;
    link_2.hideFocus = true;
    link_3.hideFocus = true;
    link_4.hideFocus = true;
    link_5.hideFocus = true;
    link_6.hideFocus = true;

    link_1.attachEvent("onclick", onLinkClick);
    link_1.attachEvent("ondblclick", onLinkDblClick);
    section_1.offsetParent.attachEvent("onresize", onResize);
    link_2.attachEvent("onclick", onLinkClick);
    link_2.attachEvent("ondblclick", onLinkDblClick);
    section_2.offsetParent.attachEvent("onresize", onResize);
    link_3.attachEvent("onclick", onLinkClick);
    link_3.attachEvent("ondblclick", onLinkDblClick);
    section_3.offsetParent.attachEvent("onresize", onResize);
    link_4.attachEvent("onclick", onLinkClick);
    link_4.attachEvent("ondblclick", onLinkDblClick);
    section_4.offsetParent.attachEvent("onresize", onResize);
    link_5.attachEvent("onclick", onLinkClick);
    link_5.attachEvent("ondblclick", onLinkDblClick);
    section_5.offsetParent.attachEvent("onresize", onResize);
    link_6.attachEvent("onclick", onLinkClick);
    link_6.attachEvent("ondblclick", onLinkDblClick);
    section_6.offsetParent.attachEvent("onresize", onResize);
    
    // Add edit link button for each section
    for (var i = 1; i <= 6; i++)
    {
        var editLink =  document.createElement("a")
        editLink.className = "editbutton";
        editLink.id = "section_edit_" + i;
        editLink.innerText = "Edit Section";
        editLink.href = "#";
        editLink.tabIndex = 1;
        
        // Find section
        var section_id = "section_" + i;
        var section = document.getElementById(section_id);

        // Append to section
        section.appendChild(editLink);
        
        // Position button/link above link text
        editLink.style.position = "absolute";
        editLink.style.left = getCtrlRight(section) - editLink.offsetWidth - 5;
        editLink.style.top = getCtrlTop(section) + 5;
    }
    i = 1;
    section_edit_1.focus();
}

function getCtrlTop(ctrl) // IN: HTML element
//
// DESCRIPTION: Returns the total offset position of the top of element 
//
{
    var top = 0;
    
    var parent = ctrl.parentElement;
    while (null != parent)
    {
        top += parent.offsetTop;
        parent = parent.offsetParent;
    }
    return top;
}

function getCtrlLeft(ctrl) // IN: HTML element
//
// DESCRIPTION: Returns the total offset position of the left of element 
//
{
    var left = 0;
    
    var parent = ctrl.parentElement;
    while (null != parent)
    {
        left += parent.offsetLeft;
        parent = parent.offsetParent;
    }
    return left;
}


function getCtrlRight(ctrl) // IN: HTML element
//
// DESCRIPTION: Returns the total offset position of the right of element 
//
{
    var right = getCtrlLeft(ctrl) + ctrl.offsetWidth + ctrl.style.paddingLeft + ctrl.style.paddingRight;
    return right;
}
