// TDS server


IPC ipc = server port               // port is passed in by api.inc

bool debug=false                    // true => diagnostic output

bool errors=false                   // have we had an error ?

void dprint(string s) {             // diagnostic routine
  if (debug) print s
}

void toDoors (string s) {   // send message, must be acknowledged

    dprint "toDoors(" s ")\n"

    if (!send(ipc, s))
      unixerror "toDoors/send"

    if (!recv(ipc, s))
      unixerror "toDoors/recv"

    dprint "Ack: " s "\n"

    if (s!="OK") eval_ s
}

void done () {   // send "done" message, no acknowledge needed

    dprint "done\n"

    if (errors)       // client has already diconnected
      errors=false
    else {
      if (!send(ipc, "done_"))
        unixerror "done/send"
    }
}

void sendError (string mess) {   // let DOORS know about an error

    if (errors)
      return

    if (!send(ipc, "errors_"))
      unixerror "error/send"
    if (!recv(ipc, s)) // the ack
      unixerror "toDoors/recv"
    if (!send(ipc, mess))
      unixerror "error/send"
}

string request
string res

#include <t2d>

checkIPC ipc          // must be provided in client specific part

print "Ready to accept commands from DOORS\n"

if (!accept ipc) unixerror "unexpected failure waiting for DOORS client"

while (true) {

  if (!recv(ipc,request)) {
    warn "DOORS has disconnected"
    break
  }

  dprint "request: " request "\n"

  errors=false

  if (request=="shutdown_")
    break  // no acknowledge needed

  ans = eval_ request

  if (ans=="errors in eval_ string") {
    print "errors in request\n"
    done
  }

  if (request=="shutdown_")
    break  // no acknowledge needed
}

closeDown       // must be provided in client specific part

